﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Cv1
{
    class Program
    {
        static void Main(string[] args)
        {

            List<Item> items = new List<Item>() {
                new Item() {
                    Name = "Auto",
                    Price = 783573.53
                },
                new Item() {
                    Name = "Kolo",
                    Price = 9833.3
                },
                new Item() {
                    Name = "Rohlíky",
                    Price = 132.5
                },
                new Item() {
                    Name = "Sekačka",
                    Price = 5703.5
                }
            };


            List<Item> result = items.Where(x => x.Price < 2000).ToList();
            




            int[] numbers = new int[] {
                18, 5, 4, 25, 74, 154,
                9, 57, 38, 666, 42
            };
            

            IEnumerable<int> forExampleResult = ForExample(numbers);
            Console.WriteLine("For/foreach:");
            Console.WriteLine(string.Join(", ", forExampleResult));
            Console.WriteLine();

            IEnumerable<int> linqMethodsExampleResult = LinqMethodsExample(numbers);
            Console.WriteLine("LINQ methods:");
            Console.WriteLine(string.Join(", ", linqMethodsExampleResult));
            Console.WriteLine();


            IEnumerable<int> linqExampleResult = LinqExample(numbers);
            Console.WriteLine("LINQ:");
            Console.WriteLine(string.Join(", ", linqExampleResult));
            Console.WriteLine();


        }

        public static IEnumerable<int> ForExample(int[] numbers)
        {
            List<int> result = new List<int>();
            foreach(int val in numbers)
            {
                if (val % 2 == 0 && val > 10) {
                    result.Add(val * 2);
                }
            }
            result.Sort();
            return result;
        }

        public static IEnumerable<int> LinqMethodsExample(int[] numbers)
        {
            return numbers
                .Where(x => x % 2 == 0 && x > 10)
                .Select(x => x * 2)
                .OrderBy(x => x);
        }



        public static IEnumerable<int> LinqExample(int[] numbers)
        {
            return from x in numbers where x % 2 == 0 && x > 10 orderby x select x * 2;
        }



    }
}
